variables:
  DOCKER_IMAGE_NAME: $CI_REGISTRY_IMAGE #Image pour le CI du repo terraformm ( /!\ Ne pas confondre avec le CD des microservies )

stages:
  - versioning
  - dockerizing
  - merging

default:
  tags:
    - fast

include:
  - project: "models8/gitlab-ci-extensions"
    ref: master
    file: '.gitlab-ci-gitVersion.yml'


get-version:
  stage: versioning
  extends: .git-version
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"



add-git-tag:
  stage : versioning
  image:
    name: alpine/curl:3.14
    entrypoint: [ "" ]
  script:
    - 'curl --request POST --header "PRIVATE-TOKEN: $GITLAB_API_TOKEN" "https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags?tag_name=v$PACKAGE_VERSION&ref=$CI_COMMIT_SHA"'
  needs:
    - job: get-version
      optional: true
      artifacts: true
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"

create-docker-image:
  stage: dockerizing
  image: docker:20.10
  services:
    - docker:20.10-dind
  variables:
    DOCKER_TLS_CERTDIR: ""
    DOCKER_HOST: tcp://docker:2375
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $DOCKER_IMAGE_NAME:$PACKAGE_VERSION .
    - docker tag $DOCKER_IMAGE_NAME:$PACKAGE_VERSION $DOCKER_IMAGE_NAME:latest
    - docker tag $DOCKER_IMAGE_NAME:$PACKAGE_VERSION $DOCKER_IMAGE_NAME:production
    - docker push --all-tags $DOCKER_IMAGE_NAME
  tags:
    - dind
  needs:
    - job: get-version
      optional: true
      artifacts: true
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"


merge-in-production:
  stage : merging
  image:
    name: alpine/git:v2.34.2
    entrypoint: [""]
  script:
    - cd /
    - git clone --branch $CI_COMMIT_BRANCH "https://PRIVATE-TOKEN:${GITLAB_API_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_PATH}.git" "${CI_COMMIT_SHA}"
    - cd $CI_COMMIT_SHA
    - git push origin $CI_COMMIT_SHA:production
    - echo "Staging pushed to Production"
  needs:
    - job: get-version
      optional: true
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"
